
_check_device:

;TC74.c,21 :: 		void check_device(unsigned short dev_address){
;TC74.c,22 :: 		I2C1_Start();
	CALL        _I2C1_Start+0, 0
;TC74.c,23 :: 		if (I2C1_Wr(dev_address)){
	MOVF        FARG_check_device_dev_address+0, 0 
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_check_device0
;TC74.c,24 :: 		Lcd_Out(1,1,"Device not found");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_TC74+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_TC74+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;TC74.c,25 :: 		}
	GOTO        L_check_device1
L_check_device0:
;TC74.c,26 :: 		else Lcd_Out(1,1,"TC74 device");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_TC74+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_TC74+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
L_check_device1:
;TC74.c,27 :: 		I2C1_Stop();
	CALL        _I2C1_Stop+0, 0
;TC74.c,28 :: 		}
	RETURN      0
; end of _check_device

_Read_Temp:

;TC74.c,30 :: 		unsigned short Read_Temp(){
;TC74.c,32 :: 		I2C1_Start();          // Issue start signal
	CALL        _I2C1_Start+0, 0
;TC74.c,33 :: 		I2C1_Wr(TC74A0);       // Address + Write bit
	MOVLW       144
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;TC74.c,34 :: 		I2C1_Wr(0x00);         // Read Temp
	CLRF        FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;TC74.c,35 :: 		I2C1_Repeated_Start(); // Issue start signal
	CALL        _I2C1_Repeated_Start+0, 0
;TC74.c,36 :: 		I2C1_Wr(TC74A0+1);     // Address + Read bit
	MOVLW       145
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
;TC74.c,37 :: 		result = I2C1_Rd(0u);
	CLRF        FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
;TC74.c,38 :: 		return result;
;TC74.c,39 :: 		}
	RETURN      0
; end of _Read_Temp

_main:

;TC74.c,42 :: 		void main() {
;TC74.c,43 :: 		CMCON = 0x07;   // Disable comparators
	MOVLW       7
	MOVWF       CMCON+0 
;TC74.c,44 :: 		ADCON1 = 0x0F;  // Disable Analog functions
	MOVLW       15
	MOVWF       ADCON1+0 
;TC74.c,45 :: 		TRISA = 0x00;
	CLRF        TRISA+0 
;TC74.c,46 :: 		TRISC = 0x00;
	CLRF        TRISC+0 
;TC74.c,47 :: 		TRISB = 0x00;
	CLRF        TRISB+0 
;TC74.c,48 :: 		I2C1_Init(100000);   // Initiate I2C
	MOVLW       120
	MOVWF       SSPADD+0 
	CALL        _I2C1_Init+0, 0
;TC74.c,49 :: 		Lcd_Init();          // Initialize LCD
	CALL        _Lcd_Init+0, 0
;TC74.c,50 :: 		Lcd_Cmd(_LCD_CLEAR);             // CLEAR display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;TC74.c,51 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);        // Cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;TC74.c,52 :: 		Lcd_Out(1,1,"Testing TC74");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_TC74+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_TC74+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;TC74.c,53 :: 		Lcd_Out(2,1,"Thermal sensor");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr4_TC74+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr4_TC74+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;TC74.c,54 :: 		Delay_ms(1000);
	MOVLW       61
	MOVWF       R11, 0
	MOVLW       225
	MOVWF       R12, 0
	MOVLW       63
	MOVWF       R13, 0
L_main2:
	DECFSZ      R13, 1, 1
	BRA         L_main2
	DECFSZ      R12, 1, 1
	BRA         L_main2
	DECFSZ      R11, 1, 1
	BRA         L_main2
	NOP
	NOP
;TC74.c,55 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;TC74.c,56 :: 		do {
L_main3:
;TC74.c,57 :: 		check_device(TC74A0);
	MOVLW       144
	MOVWF       FARG_check_device_dev_address+0 
	CALL        _check_device+0, 0
;TC74.c,58 :: 		num = Read_Temp();
	CALL        _Read_Temp+0, 0
	MOVF        R0, 0 
	MOVWF       _num+0 
;TC74.c,61 :: 		if (num > 127) {
	MOVF        R0, 0 
	SUBLW       127
	BTFSC       STATUS+0, 0 
	GOTO        L_main6
;TC74.c,62 :: 		temperature[0] = '-';
	MOVLW       45
	MOVWF       _temperature+0 
;TC74.c,63 :: 		num = ~num +1;
	COMF        _num+0, 1 
	INCF        _num+0, 1 
;TC74.c,64 :: 		}
	GOTO        L_main7
L_main6:
;TC74.c,65 :: 		else temperature[0] = '+';
	MOVLW       43
	MOVWF       _temperature+0 
L_main7:
;TC74.c,67 :: 		temperature[1] = num/100 + 48;
	MOVLW       100
	MOVWF       R4 
	MOVF        _num+0, 0 
	MOVWF       R0 
	CALL        _Div_8x8_U+0, 0
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       _temperature+1 
;TC74.c,68 :: 		temperature[2] = (num/10)%10 + 48;
	MOVLW       10
	MOVWF       R4 
	MOVF        _num+0, 0 
	MOVWF       R0 
	CALL        _Div_8x8_U+0, 0
	MOVLW       10
	MOVWF       R4 
	CALL        _Div_8x8_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       _temperature+2 
;TC74.c,69 :: 		temperature[3] = num%10 + 48;
	MOVLW       10
	MOVWF       R4 
	MOVF        _num+0, 0 
	MOVWF       R0 
	CALL        _Div_8x8_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       _temperature+3 
;TC74.c,70 :: 		temperature[5] = 223;
	MOVLW       223
	MOVWF       _temperature+5 
;TC74.c,73 :: 		if (temperature[1] == '0') {
	MOVF        _temperature+1, 0 
	XORLW       48
	BTFSS       STATUS+0, 2 
	GOTO        L_main8
;TC74.c,74 :: 		temperature[1] = ' ';
	MOVLW       32
	MOVWF       _temperature+1 
;TC74.c,75 :: 		if (temperature[2] == '0') temperature[2] = ' ';
	MOVF        _temperature+2, 0 
	XORLW       48
	BTFSS       STATUS+0, 2 
	GOTO        L_main9
	MOVLW       32
	MOVWF       _temperature+2 
L_main9:
;TC74.c,76 :: 		}
L_main8:
;TC74.c,78 :: 		Lcd_Out(2,4,temperature);
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       _temperature+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(_temperature+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;TC74.c,79 :: 		Delay_ms(500);
	MOVLW       31
	MOVWF       R11, 0
	MOVLW       113
	MOVWF       R12, 0
	MOVLW       30
	MOVWF       R13, 0
L_main10:
	DECFSZ      R13, 1, 1
	BRA         L_main10
	DECFSZ      R12, 1, 1
	BRA         L_main10
	DECFSZ      R11, 1, 1
	BRA         L_main10
	NOP
;TC74.c,80 :: 		} while(1);
	GOTO        L_main3
;TC74.c,81 :: 		}
	GOTO        $+0
; end of _main
